import { IWidgetRouter } from "./IWidgetRouter";
import { RouteResult } from "./RouteResult";
import { RouteConfig } from "./RouteConfig";
import { EventHandlerManager } from 'event-handler-manager';
export declare class WidgetRouter extends EventHandlerManager implements IWidgetRouter {
    private readonly containerId;
    private readonly routeConfig;
    private readonly appScope;
    private readonly controllerHelper;
    private readonly pageIdPrefix;
    private controllersInitiated;
    private templateProvider;
    activePage: string;
    constructor(containerId: string, routeConfig: RouteConfig, appScope?: Object, controllerHelper?: any);
    private executeController(routeName, params, templateContent, initController, currentRouteConfig);
    go(routeName: string, params?: any, noCache?: boolean, initController?: boolean): Promise<RouteResult>;
    private getTemplateFromFile(templateFile);
}
