﻿import * as xhr from "xhr";
import {ITemplateProvider} from './ITemplateProvider';

export class TemplateProvider implements ITemplateProvider {
  
  get(template: string, noCache?: boolean) {

    let version = '';
    if (noCache) {
      version = '?v=' + new Date().getTime().toString();
    }

    const dfd = new Promise<string>((resolve, reject) => {
      xhr.get(template + version, {
        timeout: 4000
      }, (error, response, body) => {
        if (error) {
          reject(error);
        } else {
          resolve(body);
        }
      });
    });
    return dfd;
  }
}